%{!?_with_bootstrap: %global bootstrap 0}
%global profile_d_dir %{_sysconfdir}/profile.d
%global maven_name maven
%global maven_home %{_datadir}/maven
%global apache_maven_jardir %{_javadir}/%{name}
%global maven_confdir %{_sysconfdir}/%{maven_name}
%global java_ver_min 1.7.0
%global subdirs aether plexus slf4j
%global aether_ver 1.0.2.v20150114

Name:           apache-maven
Version:        3.3.9
Release:        3%{?dist}
Summary:        Java project management and project comprehension tool binary
Epoch:          0

Group:          Development/Tools
License:        ASL 2.0 and MIT and BSD
URL:            http://maven.apache.org/

Source0:        http://apache.cs.utah.edu/maven/maven-3/%{version}/binaries/%{name}-%{version}-bin.tar.gz
Source1:        bash_completion.d-%{name}
Source15:       %{name}-jpp-script

BuildArch: noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?el6}"
BuildRequires: java-%{java_ver_min}-openjdk-devel
%else
BuildRequires: java-devel >= %{java_ver_min}
%endif
BuildRequires:  jpackage-utils
BuildRequires:  grep

%if ! 0%{?bootstrap}
## For auto-generate maven provides
BuildRequires: maven-local
%endif

# maven 3 Requires JDK, see http://maven.apache.org/download.cgi
Requires:  java >= %{java_ver_min}
%if "%{?el6}"
Requires: java-%{java_ver_min}-openjdk-devel
%else
Requires: java-devel >= %{java_ver_min}
Requires: aether-api
Requires: aether-impl
Requires: aether-spi
Requires: aether-util
Requires: plexus-sec-dispatcher
%endif
Requires:  jpackage-utils

# For those who need maven, but don't want or cannot install maven2 for Fedora.
# RHEL-6, for example, by default do not have maven.
Provides:  maven = %{version}-%{release}
Provides:  maven2 = %{version}-%{release}
Obsoletes: maven < %{version}



## apache-maven also provides following packages
%if "%{?el6}"
Provides: aether-api  = %{aether_ver}
Provides: aether-impl = %{aether_ver}
Provides: aether-spi  = %{aether_ver}
Provides: aether-util = %{aether_ver}
Provides: plexus-sec-dispatcher = 1.3
%endif
Provides:  plexus-cipher = 1.7-11
Obsoletes: plexus-cipher < 1.7-11
Provides:  maven-wagon = 2.10-1
Obsoletes: maven-wagon < 2.10-1
Provides:  maven-wagon-file = 2.10-1
Obsoletes: maven-wagon-file < 2.10-1
Provides:  maven-wagon-http-shared = 2.10-1
Obsoletes: maven-wagon-http-shared < 2.10-1
Provides:  maven-wagon-provider-api = 2.10-1  
Obsoletes: maven-wagon-provider-api < 2.10-1 
Provides:  slf4j = 1.7.5  
Obsoletes: slf4j < 1.7.5 

%description
Maven is a software project management and comprehension tool. Based on the
concept of a project object model (POM), Maven can manage a project's build,
reporting and documentation from a central piece of information.

Note that this package is binary version, thus cannot go in official
Fedora repo.

%prep
%setup -q
%{__sed} -i 's/\r//' LICENSE
%{__sed} -i 's/\r//' NOTICE
%{__sed} -i 's/\r//' README.txt
cp %{SOURCE15} bin/mvn-jpp
rm -f bin/*.cmd

%clean
%__rm -rf %{buildroot}

%build
mkdir -p maven-poms
for d in maven %{subdirs};do
    mkdir -p jars/$d
done
for jar in lib/*.jar; do
    deVersioned=
    if [[ "$jar" =~ -([0-9.Mv]+)\.jar$ ]];then
        deVersioned=`echo $jar | sed -e "s/-${BASH_REMATCH[1]}//"`
    else
        deVersioned=$jar
    fi
    deVersioned=$(sed -e 's|^lib/||' <<<$deVersioned)
    GaArray=($(jar tf $jar | sed -n -e '/pom.xml/ s|META-INF/maven/\(.*\)/pom.xml|\1|p'))
    if [[ -n "$GaArray" ]];then
        for ga in ${GaArray[@]};do
            if [[ "$ga" =~ ([^/]*)/([^/]*) ]];then
                GroupId=${BASH_REMATCH[1]}
                GroupShort=$(sed -e 's/.*\.//' <<<$GroupId)
                ArtifactId=${BASH_REMATCH[2]}
		if [[ ! $deVersioned =~ $ArtifactId ]];then
		    continue
		fi
                jar xf $jar META-INF/maven/$ga/pom.xml
                cp META-INF/maven/$ga/pom.xml maven-poms/JPP.$GroupShort-$ArtifactId.pom
                %mvn_artifact maven-poms/JPP.$GroupShort-$ArtifactId.pom $jar
            fi
         done
    else
	deVersioned=$(sed -e 's|^lib/||' <<<$deVersioned)
    fi
    case $deVersioned in
        aether* )
	    ## Compatible (older version)
	    cp $jar jars/aether/$(basename $jar)
	    ;;
	plexus-sec-dispatcher* )
	    ## Compatible (older version)
	    cp $jar jars/plexus/$(basename $jar)
	    ;;
	plexus* )
	    cp $jar jars/plexus/$deVersioned
	    ;;
	slf4j* )
	    cp $jar jars/slf4j/$deVersioned
	    ;;
	* )
	    cp $jar jars/maven/$deVersioned
	    ;;
    esac
done
cd -


%install
%__rm -rf %{buildroot}
%__mkdir -p %{buildroot}%{_sysconfdir}/bash_completion.d
%__install -pm 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/bash_completion.d/%{maven_name}
%mvn_install -X

install -d -pm 755 %{buildroot}%{_bindir} \
                   %{buildroot}%{maven_home}/bin \
                   %{buildroot}%{maven_home}/boot \
		   %{buildroot}%{maven_home}/conf \
		   %{buildroot}%{maven_home}/lib \
                   %{buildroot}%{_sysconfdir} \
		   %{buildroot}%{maven_confdir} \
		   %{buildroot}%{profile_d_dir} \
		   %{buildroot}%{_javadir}/maven \
		   %{buildroot}%{_javadir}/aether \
		   %{buildroot}%{_javadir}/plexus \
		   %{buildroot}%{_javadir}/slf4j \


## bin
install -pm 644 bin/m2.conf %{buildroot}%{_sysconfdir}/
ln -sf %{_sysconfdir}/m2.conf %{buildroot}%{maven_home}/bin
install -pm 755 bin/mv* %{buildroot}%{maven_home}/bin
for f in bin/mv*;do
    ln -sf %{maven_home}/$f %{buildroot}%{_bindir}/
done

## boot
install -pm 644 boot/* %{buildroot}%{maven_home}/boot

## conf: maven/conf dir structure should match Fedora/RHEL
cd conf
for f in *;do
    if [ -d $f ];then
        cp -r $f %{buildroot}%{maven_confdir}
    else
        %__install -pm 644 $f %{buildroot}%{maven_confdir}
    fi
    ln -sf %{maven_confdir}/$f %{buildroot}%{maven_home}/conf/$f
done
cd -


%__cat >>%{buildroot}%{profile_d_dir}/apache-maven.sh <<EOF
MAVEN_HOME=%{maven_home}
M2_HOME=\$MAVEN_HOME
export MAVEN_HOME
export M2_HOME
EOF

%__cat >>%{buildroot}%{profile_d_dir}/apache-maven.csh <<EOF
setenv MAVEN_HOME %{maven_home}
setenv M2_HOME \$MAVEN_HOME
EOF

## lib
for jar in $(find jars -name '*.jar' | xargs); do
    d=$(sed -ne 's|jars/\(.*\)/[^/]*$|\1|p' <<<$jar) 
    f=$(sed -ne 's|jars/.*/\([^/]*\)$|\1|p' <<<$jar)
    jarDest=%{_javadir}/$d/$f
    install -pm 644 $jar %{buildroot}/$jarDest
    ln -s $jarDest %{buildroot}%{maven_home}/lib/$d_$f
done

%files -f .mfiles
%defattr(-,root,root,-)
%doc LICENSE  NOTICE  README.txt
%{_bindir}/m*
%{maven_home}
%{_javadir}/aether
%{_javadir}/maven
%{_javadir}/plexus
%{_javadir}/slf4j
%config %{profile_d_dir}/apache-maven.*sh
%config(noreplace) %{_sysconfdir}/m2.conf
%config(noreplace) %{_sysconfdir}/%{maven_name}
%config(noreplace) %{_sysconfdir}/bash_completion.d/%{maven_name}

%changelog
* Wed Nov 02 2016 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.9-3
- Automatic maven provides.
- Also install pom.xml

* Thu May 26 2016 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.9-2
- Add provides: maven, plexus-cipher, plexus-sec-dispatcher,
  maven-wagon

* Wed May 11 2016 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.9-1
- Upstream update to 3.3.9

* Wed Oct 21 2015 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.3-4
- CentOS 6 only has java-<ver>-openjdk-devel, but not java-devel-<ver>

* Mon Oct 19 2015 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.3-3
- Remove Epoch on JDK dependencies.

* Wed Oct 14 2015 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.3-2
- Version 3.3.3 require Java 1.7

* Thu Oct 08 2015 Ding-Yi Chen <dchen at redhat.com> - 0:3.3.3-1
- Upstream update to 3.3.3

* Mon Jan 19 2015 Ding-Yi Chen <dchen at redhat.com> - 0:3.2.5-1
- Upstream update to 3.2.5

* Tue Nov 25 2014 Ding-Yi Chen <dchen at redhat.com> - 0:3.2.3-1
- Upstream update to 3.2.3
- Change the mirror URL.

* Mon Jun 16 2014 Ding-Yi Chen <dchen at redhat.com> - 0:3.2.1-2
- Setting files are set with (noreplace)
- The file structure is now looks like maven in RHEL7
- Executables are available in /usr/bin
- /usr/share/apache-maven/conf is now a link to /etc/maven.
  So rpm -Uvh might not work, please remove the previous apache-maven
  before install this version.

* Tue Mar 04 2014 Ding-Yi Chen <dchen at redhat.com> - 0:3.2.1-1
- Upstream update to 3.2.1
- Fixed java.io.FileNotFoundException: /usr/share/apache-maven/conf/logging


* Thu Feb 13 2014 Ding-Yi Chen <dchen at redhat.com> - 0:3.1.1-1
- Upstream update to 3.1.1

* Wed Aug 3 2011 Ding-Yi Chen <dchen at redhat.com> - 0:3.0.3-1
- Upstream update to 3.0.3

* Thu Dec 9 2010 Sean Flanigan <sflaniga at redhat dot com> - 0:3.0-4
- Removed broken .jar links

* Fri Dec 3 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:3.0-3
- Added: provide maven2, For those who need maven, but don't want or
  cannot install maven2 for Fedora.


* Fri Nov 26 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:3.0-2
- Now requires java-devel instead of java, as mvn seems require javac
  to work properly.

* Tue Oct 12 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:3.0-1
- Update to Maven3.

* Thu Jul 08 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:2.2.1-7
- Don't tried to replace the whole Fedora's maven2, but cooperate with it.
  but still insert itself before Fedora's maven2.

* Thu Apr 01 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:2.2.1-6
-Correct the apache-maven.csh

* Wed Mar 31 2010 Ding-Yi Chen <dchen at redhat dot com> - 0:2.2.1-5
-Correct the maven-plugins version.

* Mon Mar 29 2010 Ding-Yi Chen <dchen at redhat dot com> - 2.2.1-4
-Add Epoch
-Add plugins

* Tue Mar 09 2010 Ding-Yi Chen <dchen at redhat dot com> - 2.2.1-3
Fixed profile.d scripts

* Tue Mar 09 2010 Ding-Yi Chen <dchen at redhat dot com> - 2.2.1-2
Modify conflicts

* Tue Mar 09 2010 Ding-Yi Chen <dchen at redhat dot com> - 2.2.1-1
- Initial package.

